using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Mythos._3_Vistas.Listados
{
    public class ABS_Listado_MYT_PartesLineas_Trazabilidad : ABS_Listado
    {
        //Variables privadas
        private INTERNO_ValoresGenerales_Modelo g_mdl_INTERNO_ValoresGenerales_Modelo = null;
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_MYT_PartesLineas_Trazabilidad(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo)
        {
            g_mdl_INTERNO_ValoresGenerales_Modelo = _mdl_INTERNO_ValoresGenerales_Modelo;

            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //Lote
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.lote), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.lote), "Lote", G_ENUM_TIPOSDATOS.TEXT, false, 80, true, true, true, false, "", null));

            //Fecha Caducidad
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.fechaCaducidad), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.fechaCaducidad), "Fecha caducidad", G_ENUM_TIPOSDATOS.DATETIME, false, 80, true, false, true, false, "", null));

            //Cantidad
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.cantidad), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.cantidad), "Cantidad", G_ENUM_TIPOSDATOS.DECIMAL, false, 80, true, true, true, false, "", null, false));

            //2º Unidad
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.segundaUnidad_cantidad), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.segundaUnidad_cantidad), "2º Unidad", G_ENUM_TIPOSDATOS.DECIMAL, false, 80, true, true, true, false, "", null, true));

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_MYT_PARTELINEA_TRAZABILIDAD);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_MYT_PARTELINEA_TRAZABILIDAD;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_MYT_PartesLineas_Trazabilidad_Listado_Modelo.lote);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
